//HavokActor.h
#ifndef _HAVOKACTOR_H
#define _HAVOKACTOR_H

#include <Common/Base/hkBase.h>

#include "HavokDefine.h"
#include "PhysicsDefine.h"

class hkpCharacterProxy;
using namespace PhysicsDefine;

#ifdef USE_HAVOKDEMO
class HavokActor : public hkReferencedObject
#else
class HavokActor
#endif
{
public:
#ifdef USE_HAVOKDEMO
	HK_DECLARE_CLASS_ALLOCATOR(HK_MEMORY_CLASS_DEMO);
#endif
	HavokActor();
	virtual ~HavokActor();

	void	CreateCapsuleProxy( const hkVector4& position, float strength = 5000, float mass = 100 );
	void	DeleteProxy();
	void	UpdateStep( float timestep );
	hkpCharacterProxy* GetProxy()
	{
		return m_characterProxy;
	}
	void	SetPosition( float x, float y, float z );
	bool	GetPosition( Vector3& pos );
	bool	IsSupported();
	
private:
	class hkpCharacterContext* m_characterContext;
	hkpCharacterProxy*  m_characterProxy;
	hkVector4			m_up;
	hkVector4			m_forward;
};

#endif