//DxVertex.h
#ifndef _DXMESH_H
#define _DXMESH_H


//ؽ ü Ÿ 
struct DxVertex
{
	DxVertex(){}
	D3DXVECTOR3 position;
	D3DXVECTOR3 normal;

	static const DWORD FVF;
};
//const DWORD DxVertex::FVF = D3DFVF_XYZ | D3DFVF_NORMAL;

struct DxIndex
{
	WORD	index;
};

class DxMesh
{
public:
	DxMesh();
	~DxMesh();

public:
	DxVertex* GetVertexBuffer()
	{
		return m_vb;
	}
	void SetVertexBuffer( DWORD vertexNum, DxVertex* vb )
	{
		m_vertexNum = vertexNum;
		m_vb = vb;
	}

	DxIndex* GetIndexBuffer()
	{
		return m_ib;
	}
	void SetIndexBuffer( DWORD indexNum, DxIndex* ib )
	{
		m_indexNum = indexNum;
		m_ib = ib;
	}

	void	Render();

	void	SetWireFrame( bool bFlag )
	{
		m_bWireFrame = bFlag;
	}

	void	SetTransform( const D3DXMATRIX& mat )
	{
		m_trans = mat;
	}

protected:
	bool	CreateVertexBuffer();
	void	Release();

protected:
	DWORD		m_indexNum, m_vertexNum;
	DxVertex*	m_vb;
	DxIndex*	m_ib; 

	ID3DXMesh*	m_pMesh;
	bool		m_bWireFrame;
	D3DXMATRIX	m_trans;
};


#endif