//HavokDebug.h
#ifndef _HAVOKDEBUG_H
#define _HAVOKDEBUG_H

#include <vector>

#include <Physics/Dynamics/Entity/hkpRigidBody.h>
#include <Common/SceneData/Scene/hkxScene.h>

#include <Common/SceneData/Mesh/hkxMeshSection.h>

class hkxScene;
class DxMesh;
class hkpPhysicsData;


struct MeshInfo
{
	std::string		name;
	DxMesh*			dxMesh;
	hkpRigidBody*	refRigidBody;
};

class HavokDebug
{
public:
	static bool CreateInstance();
	static void ReleaseInstance();
	static HavokDebug* Instance();

public:
	HavokDebug();
	~HavokDebug();

	bool	Init();
	void	UnInit();

	void	MakeMesh( hkxScene* scenePtr, hkpPhysicsData* physics );
	void	MakeMesh( hkpShape* pShape, hkpRigidBody* pRigidBody );
	void	Render();

protected:
	void	BuildMesh( hkxScene* scenePtr, hkpPhysicsData* physics, hkxNode* pNode, hkxMesh* pMesh );
	void	MakeStaticMesh( hkxScene* scenePtr, hkpPhysicsData* physics, hkxNode* pNode );
	void    MakeVertex( hkxMeshSection* section, const hkMatrix4& worldTransform );

protected:
	static HavokDebug* m_pInstance;
	hkArray<hkxMeshSection*> m_sections;

	std::vector< MeshInfo > m_meshArr;
};

#endif